com.io7m.smfj.bytebuffer

## Class SMFByteBufferPackedAttributeSet

- java.lang.Object
- - com.io7m.smfj.bytebuffer.SMFByteBufferPackedAttributeSet

- All Implemented Interfaces:
    SMFByteBufferPackedAttributeSetType

      @Generated(value={"Immutables.generator","SMFByteBufferPackedAttributeSetType"})
      public final class SMFByteBufferPackedAttributeSet
      extends Object
      implements SMFByteBufferPackedAttributeSetType

  A set of packed attributes in a byte buffer.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SMFByteBufferPackedAttributeSet.Builder` Builds instances of type `SMFByteBufferPackedAttributeSet`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static SMFByteBufferPackedAttributeSet.Builder` | `builder()` Creates a builder for `SMFByteBufferPackedAttributeSet`.
    `ByteBuffer` | `byteBuffer()`
    `SMFByteBufferPackingConfiguration` | `configuration()`
    `static SMFByteBufferPackedAttributeSet` | `copyOf(SMFByteBufferPackedAttributeSetType instance)` Creates an immutable copy of a `SMFByteBufferPackedAttributeSetType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `SMFByteBufferPackedAttributeSet` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `id`, `configuration`, `byteBuffer`.
    `int` | `id()`
    `static SMFByteBufferPackedAttributeSet` | `of(int id, SMFByteBufferPackingConfiguration configuration, ByteBuffer byteBuffer)` Construct a new immutable `SMFByteBufferPackedAttributeSet` instance.
    `String` | `toString()` Prints the immutable value `SMFByteBufferPackedAttributeSet` with attribute values.
    `SMFByteBufferPackedAttributeSet` | `withByteBuffer(ByteBuffer value)` Copy the current immutable object by setting a value for the `byteBuffer` attribute.
    `SMFByteBufferPackedAttributeSet` | `withConfiguration(SMFByteBufferPackingConfiguration value)` Copy the current immutable object by setting a value for the `configuration` attribute.
    `SMFByteBufferPackedAttributeSet` | `withId(int value)` Copy the current immutable object by setting a value for the `id` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### id

          public int id()

      Specified by:
        `id` in interface `SMFByteBufferPackedAttributeSetType`
      Returns:
        The identifier of the set; must be unique within a mesh

    - #### configuration

          public SMFByteBufferPackingConfiguration configuration()

      Specified by:
        `configuration` in interface `SMFByteBufferPackedAttributeSetType`
      Returns:
        The packing configuration for the set

    - #### byteBuffer

          public ByteBuffer byteBuffer()

      Specified by:
        `byteBuffer` in interface `SMFByteBufferPackedAttributeSetType`
      Returns:
        The byte buffer containing a set of packed attributes

    - #### withId

          public final SMFByteBufferPackedAttributeSet withId(int value)

      Copy the current immutable object by setting a value for the `id` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for id
      Returns:
        A modified copy of the `this` object

    - #### withConfiguration

          public final SMFByteBufferPackedAttributeSet withConfiguration(SMFByteBufferPackingConfiguration value)

      Copy the current immutable object by setting a value for the `configuration` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for configuration
      Returns:
        A modified copy of the `this` object

    - #### withByteBuffer

          public final SMFByteBufferPackedAttributeSet withByteBuffer(ByteBuffer value)

      Copy the current immutable object by setting a value for the `byteBuffer` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for byteBuffer
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `SMFByteBufferPackedAttributeSet` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `id`, `configuration`, `byteBuffer`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `SMFByteBufferPackedAttributeSet` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static SMFByteBufferPackedAttributeSet of(int id,
                                                           SMFByteBufferPackingConfiguration configuration,
                                                           ByteBuffer byteBuffer)

      Construct a new immutable `SMFByteBufferPackedAttributeSet` instance.
      Parameters:
        `id` - The value for the `id` attribute
        `configuration` - The value for the `configuration` attribute
        `byteBuffer` - The value for the `byteBuffer` attribute
      Returns:
        An immutable SMFByteBufferPackedAttributeSet instance

    - #### copyOf

          public static SMFByteBufferPackedAttributeSet copyOf(SMFByteBufferPackedAttributeSetType instance)

      Creates an immutable copy of a `SMFByteBufferPackedAttributeSetType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable SMFByteBufferPackedAttributeSet instance

    - #### builder

          public static SMFByteBufferPackedAttributeSet.Builder builder()

      Creates a builder for `SMFByteBufferPackedAttributeSet`.
      Returns:
        A new SMFByteBufferPackedAttributeSet builder

Copyright © 2017 <code@io7m.com> http://io7m.com